package textBookEgs_Chapter3;

import java.awt.Point;
import java.util.List;
import java.util.Vector;

/**
 * Encapsulation of LineDrawModel, taken from Olsen Fig 2.5, p. 19 (called
 * DrawModel in that figure); also Fig 3.15, p. 67
 * 
 * 
 * MB: notice that this model does not provide for the possibility for it to
 * have _listeners_ installed on it (such as those that a view might have so
 * that it can redraw itself in response to model changed events)
 * 
 * @author mb
 * 
 */
public class LineDrawModelV0 {

	private List<Line> linesToDraw;

	public LineDrawModelV0() {
		linesToDraw = new Vector<Line>();
	}

	/**
	 * Adds the line specified by the passed x,y endpoint coordinates and
	 * returns its index
	 * 
	 * @param x1
	 * @param y1
	 * @param x2
	 * @param y2
	 * @return
	 */
	public int addLine(int x1, int y1, int x2, int y2) {
		Line line = new Line(x1, y1, x2, y2);
		linesToDraw.add(line);
		return linesToDraw.size() - 1;
	}

	public int getNumberOfLines() {
		return linesToDraw.size();
	}

	public Point getEndPoint2(int index) {
		return linesToDraw.get(index).getEndPoint();
	}

	public Point getEndPoint1(int index) {
		return linesToDraw.get(index).getStartPoint();
	}

}
