package textBookEgs_Chapter3;

import java.awt.Component;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;

public class MyLineDrawListener implements LineDrawListener {

	private Component view;
	private LineDrawModel model;

	public MyLineDrawListener(Component view, LineDrawModel model) {
		this.view = view;
		this.model = model;
	}

	@Override
	public void lineWillChange(int index, int newX1, int newY1, int newX2,
			int newY2) {
		Line line = model.getLine(index);
		if (line != null) {
			Rectangle oldRegion = new Rectangle(line.getStartPoint().x,
					line.getStartPoint().y, line.getEndPoint().x,
					line.getEndPoint().y);
			view.invalidate(); // need to find a way to damage a region
								// selectively
		}
		Rectangle newRegion = new Rectangle(newX1, newY1, newX2, newY2);
		view.invalidate();// need to find a way to damage a region
		// selectively

	}

	@Override
	public void modelHasChanged() {
		view.invalidate();
	}

	// The following methods are specified in the MouseListener

	@Override
	public void mouseClicked(MouseEvent e) {
		// as an exercise, experiment with removing and adding mouse listener
		// from view - you will see that this method is invoked only when the
		// mouse listener is installed
		System.out.println("Click on point: " + e.getPoint());
	}

	@Override
	public void mousePressed(MouseEvent e) {
	}

	@Override
	public void mouseReleased(MouseEvent e) {
	}

	@Override
	public void mouseEntered(MouseEvent e) {
	}

	@Override
	public void mouseExited(MouseEvent e) {
	}

	@Override
	public void mouseDragged(MouseEvent e) {
	}

	// The following methods are specified in the MouseMotionListener

	@Override
	public void mouseMoved(MouseEvent e) {

		// as an exercise, experiment with removing and adding mouse motion
		// listener
		// from view - you will see that this method is invoked only when the
		// mouse motion listener is installed

		System.out.print(e.getPoint());
		if (model.nearestLine(e.getPoint()) != null) {
			System.out.print(" near to line with index: "
					+ model.nearestLine(e.getPoint()));
		}
		System.out.println();

	}

}
